// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.OpenXR
{
    [NativeName("Name", "XrHandMeshVertexMSFT")]
    public unsafe partial struct HandMeshVertexMSFT
    {
        public HandMeshVertexMSFT
        (
            Vector3f? position = null,
            Vector3f? normal = null
        ) : this()
        {
            if (position is not null)
            {
                Position = position.Value;
            }

            if (normal is not null)
            {
                Normal = normal.Value;
            }
        }

/// <summary></summary>
        [NativeName("Type", "XrVector3f")]
        [NativeName("Type.Name", "XrVector3f")]
        [NativeName("Name", "position")]
        public Vector3f Position;
/// <summary></summary>
        [NativeName("Type", "XrVector3f")]
        [NativeName("Type.Name", "XrVector3f")]
        [NativeName("Name", "normal")]
        public Vector3f Normal;
    }
}
